<?php 
// Rozen tdy TCPDF pro lep umstn hlaviky a patiky,
// vychz z pklad dokumentace TCPDF.
class MYPDF extends TCPDF 
{
    public function Header() {}

    public function Footer() {
        // Umstn textu 15 mm od okraje strnky, hodnoty jsou v mm.
        $this->SetY(-15);
        // Nastaven fontu na Helvetica a vchoz velikosti 12.
        $this->SetFont('helvetica', 'I', 8);
        // Pidn sla strnky do pdf.
        $this->Cell(0, 10, $this->getAliasNumPage().' / '.$this->getAliasNbPages(), 0, false, 'C', 0, '', 0, false, 'T', 'M');        
    }
}

// Tvorba novho pdf dokumentu.
$pdf = new MYPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

// Umouje ovlivnit vlastnosti pdf dokumentu vytvoenho touto aplikac. 
$pdf->SetCreator(PDF_CREATOR);
$pdf->SetAuthor('Martin Hlavacek');
// $pdf->SetTitle('TCPDF Example 003');
// $pdf->SetSubject('TCPDF Tutorial');
// $pdf->SetKeywords('TCPDF, PDF, example, test, guide');

// Nastaven vchozch dat hlaviky.
$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE, PDF_HEADER_STRING);

// Nastaven fontu hlaviky a patiky.
$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

// Vchoz font.
$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

// Nastaven odsazen.
$pdf->SetMargins(PDF_MARGIN_LEFT, 15, PDF_MARGIN_RIGHT);
$pdf->SetHeaderMargin(1);
$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

// Nastaven konc stran.
$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

// Nastaven klovn obrzk.
$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

// Nastaven chovn string, kter zvis na jazyku (voliteln).
if (@file_exists(dirname(__FILE__).'/lang/ces.php')) {
    require_once(dirname(__FILE__).'/lang/ces.php');
    $pdf->setLanguageArray($l);
}


// Nastaven vchozho fontu pro podmnoiny pro nenastaven texty.
$pdf->setFontSubsetting(true);

// Nastaven fontu (dal monosti obsaen v knihovn TCPDF).
// $pdf->SetFont('times', '', 9);
// $pdf->SetFont('dejavusans', '', 9);
// $pdf->SetFont('arial', '', 9);
// $pdf->SetFont('arimo', '', 9);
// $pdf->SetFont('roboto', '', 8);
$pdf->SetFont('freeserif', '', 9);

unset($_SESSION['data'][0]);
?>
