<?php
session_start() ;
// Načtení potřebných tříd.
require_once('Classes/tcpdf.php');
require_once('Classes/config.php');

// ---------------------------------------------------------
// Tvorba proměnných pro načtení dat, proměnná xlsData drží více dat.
// ---------------------------------------------------------
$codeBill = 0;
$i = 0;
$j = 0;
$xlsData = [];

// Používání stejných informací napříč daným souborem.
// Přidání (postincrement) proměnné i.
// Přidání proměnné i jako číslo stránky do patičky.
// Rozdělování položek do objednávek dle čísel objednávek.

foreach ($_SESSION['data'] as $key => $value) 
{
    $xlsData = $value;

    if ($codeBill != $xlsData[0])
    {
        $i++;
        $data[$i]['header'] = $xlsData;
        $codeBill =$xlsData[0];
    }
    if ($xlsData[47] == '0' AND $xlsData[45] == '' AND $xlsData[46] == '')
    {
        $data[$i]['footer'][] = $xlsData;
    }
    else
    {
        $sortingKey = !isset($xlsData[43]) ? 'ZZZZZZZZZZ' . $j++ : $xlsData[43];
        $data[$i]['detail'][$sortingKey] = $xlsData;
    }
}
// Načítání xlsx souboru do xlsData a přiřazení jednotlivých dat dle 
// hlavičky sloupce, v případě změny pořadí sloupce ze strany Shoptet 
// je třeba zde párování sloupců změnit.
foreach ($data as $key => $value) 
{
    $xlsData = $value['header'];

    $code = $xlsData[0];
    $date = date('d.m.Y',strtotime($xlsData[1]));
    $email = $xlsData[5];
    $phone = $xlsData[6];
    $billFullName = $xlsData[7];
    $billCompany = $xlsData[8];
    $billStreet = $xlsData[9];
    $billHouseNumber = $xlsData[10];
    $billCity = $xlsData[11];
    $billZip = $xlsData[12];
    $billCountryName = $xlsData[13];

    $companyId = $xlsData[14];
    $vatId = $xlsData[15];
    $deliveryFullName = $xlsData[16];
    $deliveryCompany = $xlsData[17];
    $deliveryVatId = $xlsData[18];
    $deliveryStreet = $xlsData[19];
    $deliveryHouseNumber = $xlsData[20];
    $deliveryCity = $xlsData[21];
    $deliveryZip = $xlsData[22];
    $deliveryCountryName = $xlsData[23];

    $remark = $xlsData[25];

// Ovlivnění zobrazení pole vpravo nahoře na dokumentu s rozdílnou adresou.
    $address = "";
    if($billFullName == $deliveryFullName &&
        $billStreet == $deliveryStreet &&
        $billCity == $deliveryCity &&
        $billZip == $deliveryZip &&
        $billCountryName == $deliveryCountryName)
    {
        $deliveryFullName = "";
        $deliveryCompany = "";
        $deliveryStreet = "";
        $deliveryHouseNumber = "";
        $deliveryCity = "";
        $deliveryZip = "";
        $deliveryCountryName = "";
    }
    else
    {
        $deliveryZip .= ",";
        $address ="Doručovací adresa:";
    }

// Přidání měny (převod EUR, USD na symboly).    
$currency = 'Kč';
    if ($xlsData['3'] == 'EUR')
        $currency = '€';
    if ($xlsData['3'] == 'GBP')
        $currency = '£';
    if ($xlsData['3'] == 'USD' OR $xlsData['3'] == 'AUD')
        $currency = '$';

    // Přidání stránky.
    $pdf->AddPage();

    // Zarovnání textu.
    $padding = 6;

    // Seřadí detail objednávky (položky v objednávce).
    if (isset($value['detail']) > 0 )
        ksort($value['detail'], SORT_STRING);

// ---------------------------------------------------------
// Tvorba obsahu.
// ---------------------------------------------------------
// Tvorba čárového kodu.
$barcodeStyles = array(
    'position' => 'L',
    'align' => 'C',
    'cellfitalign' => '',
    'hpadding' => '2px',
    'fgcolor' => array(0,0,0),
    'text' => true,
    'font' => 'helvetica',
    'fontsize' => 12,
    'stretchtext' => 0
);

$barcode = 
    '<tcpdf method="write1DBarcode" params="' . 
    $pdf->serializeTCPDFtagParameters([$code, 'C128', '', '', 45, 20, 0.4, $barcodeStyles, 'N']) . 
    '" />';

// Generování textu s číslem objednávky, byla použita metoda EOD – HEREDOC string bez středníku.
$orderId = <<<EOD
    <span style="font-size:15px;">Objednávka č.:</span>
    <span style="font-size:19px; font-weight: bold: ">{$code}</span>
EOD;

// Umístění a načtení fakturační adresy z proměnných.
$billingAddress = <<<EOD
<style>
    h4 { font-weight: normal; font-size: 13px;}
    strong { font-size: 14px;}
    span { font-size: 13px;}
</style>
<table border="0" cellspacing="0" cellpadding="{$padding}">
    <tr>
        <td><h4>Příjemce:</h4>
            <strong>{$billCompany} <br />
                {$billFullName} <br />
                {$billStreet} {$billHouseNumber}<br />
                {$billZip} {$billCity}<br />
                {$billCountryName}<br />
            </strong>
            <br /><span>Email: {$email}<br />
                Telefon: {$phone}
            </span>
        </td>
    </tr>
</table>
EOD;

// Umístění čárového kodu a načtení proměnné date (objednávka ze dne).
$barcodeAndDate = <<<EOD
<style>
    table { border-right: 1px solid black); border-top:1px solid black; }
    td { text-align: right; }
</style>
<table border="0" cellspacing="0" cellpadding="{$padding}">
    <tr>
        <td>{$barcode}</td>
        <td>Ze dne: {$date}</td>
    </tr>
</table>
EOD;

// Zobrazení doručovací adresy pouze pokud je rozdílná od fakturační.
$shippingAddress = <<<EOD
<style>
    h4 { font-weight: normal; font-size: 13px;}
    table { border-right: 1px solid black; border-bottom: 1px solid black;}
    table td { height: 160px;}
    strong { font-size: 14px;}
    span { font-size: 13px;}
</style>
<table border="0" cellspacing="0" cellpadding="{$padding}">
    <tr>
        <td><h4>{$address}</h4>
            <br /><strong>{$deliveryCompany}<br />
                {$deliveryFullName}<br />
                {$deliveryStreet} {$deliveryHouseNumber}<br />
                {$deliveryZip} {$deliveryCity}<br />
                {$deliveryCountryName}
            </strong>
        </td>
    </tr>
</table>
EOD;

// Umístění a zobrazení hlavičky tabulky nad položkami.
$tableHeader = <<<EOD
    <tr class="tableHeader">
        <th width="300" class="first">Číslo dodávky</th>
        <th width="45">Množství </th>
        <th width="45" align="right" >Cena za kus</th>
        <th width="45" align="right" >Cena</th>
        <th width="45" align="right" >Sleva</th>
        <th width="45" align="right" >DPH %</th>
        <th width="45" align="right" >DPH</th>
        <th width="68" align="right" class="last">Celková cena vč. DPH</th>
    </tr>
EOD;

// Přidání položek, pouze pokud objednávka nějaké položky obsahuje, včetně podpory desetinných míst float/double.
$tableBody = null;
$subTotal[1] = 0;
$subTotal[2] = 0;
$subTotal[3] = 0;

if (isset($value['detail']) > 0 )
{
    foreach ($value['detail'] as $key => $val) 
    {
        $subTotal[1] = number_format((double)$val[36],2,',',' ');
        $subTotal[2] = number_format((double)$val[37],2,',',' ');
        $subTotal[3] = number_format((double)$val[39],2,',',' ');

        $val[50] = number_format((double)$val[50],2,',',' ');
        $val[54] = number_format((double)$val[54],2,',',' ');
        $val[55] = number_format((double)$val[55],2,',',' ');
        $val[53] = number_format((double)$val[53],2,',',' ');

        $style = ((int)$val[42] > 1) ? 'style=" font-weight: bold; text-decoration: underline; font-size: 12px;"' : null; 
// Načtení čísla produktu (umístění a kódu zboží) a počtu kusů.
        $variant =  (isset($val[44])) ? '<br />&nbsp;&nbsp;Varianta: ' . $val[44] : '';

        $itemCode =  (isset($val[43])) ? '<br />&nbsp;&nbsp;Kód: ' . $val[43] : '';
// Načtení cen položek a jejich tisk.
        $tableBody .= <<<EOD
        <tr class="tableBody">
            <td class="first">{$val[41]}{$variant}{$itemCode}</td>
            <td {$style}>{$val[42]} {$val[46]} </td>
            <td align="right" >{$val[50]} {$currency}</td>
            <td align="right" >{$val[54]} {$currency}</td>
            <td align="right" >0 %</td>
            <td align="right" >{$val[52]} %</td>
            <td align="right" >{$val[55]} {$currency}</td>
            <td align="right" class="last">{$val[53]} {$currency}</td>
        </tr>
EOD;
    }
}

// Vložení typu platby, např. Dobírka. 
$tableShippingAndPayment = null;
if (isset($value['footer']))
{
    foreach ($value['footer'] as $key => $val) 
    {
        $val[50] = number_format((double)$val[50],2,',',' ');

        $tableShippingAndPayment .= <<<EOD
        <tr class="tableShippingAndPayment">
            <td  align="left" class="first" >{$val[41]}</td>
            <td  align="left" >{$val[42]} {$val[46]} </td>
            <td  align="right" >{$val[50]} {$currency}</td>
            <td  align="right" >{$val[54]} {$currency}</td>
            <td  align="right" >0 %</td>
            <td  align="right" >{$val[52]} %</td>
            <td  align="right" >{$val[55]} {$currency}</td>
            <td  align="right" class="last">{$val[53]} {$currency}</td>
        </tr>
EOD;
    }
}

// Součet cen položek.
$tableFooter = <<<EOD
<tr class="tableFooter">
    <td width="300" align="left" class="first" >Shrnutí <br /> <strong> K ZAPLACENÍ</strong></td>
    <td width="45" align="left" > </td>
    <td width="45" align="right" ></td>
    <td width="45" align="right" >{$subTotal[1]} {$currency}</td>
    <td width="45" align="right" ></td>
    <td width="45" align="right" ></td>
    <td width="45" align="right" >{$subTotal[2]} {$currency}</td>
    <td width="68" align="right" class="last"><strong style="font-size:9pt"> {$subTotal[3]} {$currency}</strong></td>
</tr>
EOD;

// Ohraničení textu.
$padding = 1;
$table = <<<EOD
    <style>
        table {font-size:10px;}
        .tableHeader th { border-bottom: 1px solid black; border-top: 1px solid black; font-weight: bold; }
        .tableHeader th.first { border-left: 1px solid black; }
        .tableHeader th.last { border-right: 1px solid black; }

        .tableBody td.first{ border-left: 1px solid black; }
        .tableBody td.last{ border-right: 1px solid black; } 

        .tableShippingAndPayment td.first{ border-left: 1px solid black; }
        .tableShippingAndPayment td.last{ border-right: 1px solid black; }

        .tableFooter td { border: 1px solid fuchsia; }
        .tableFooter td { border-bottom: 1px solid black; border-top: 1px solid black; font-weight: bold; }
        .tableFooter td.first { border-left: 1px solid black; }
        .tableFooter td.last { border-right: 1px solid black; }
    </style>

    <table border="0" cellspacing="0" cellpadding="{$padding}">
        {$tableHeader}
        {$tableBody}
        {$tableShippingAndPayment}
        {$tableFooter}
    </table>
EOD;

// Poznámky od zákazníka.
$notes = <<<EOD
<style>
    h4 { font-weight: normal; font-size: 13px;}
    strong { font-size: 14px;}
    span { font-size: 13px;}
</style>
<table border="0" cellspacing="0" cellpadding="{$padding}">
    <tr>
        <td><h4>Poznámka:</h4>
            <br /><span>{$remark}
            </span>
        </td>
    </tr>
</table>
EOD;


// Metoda z knihovny TCPDF pro tisk buněk a jejich umístění a ohraničení, délka ohraničení dle souřadnic, vše uvedeno v milimetrech.

$pdf->writeHTMLCell(
    null, 8, 
// šířka a výška
    null, null, 
// x a y umístění 
    $orderId, 0, 1, 0, true, 'R', false);

$pdf->writeHTMLCell(
    90, 70,
    null, null,
    $billingAddress, 1, 0, 0, true, 'J', false);

$pdf->writeHTMLCell(
    92, null,
    $pdf->GetX() - 1, null, 
    $barcodeAndDate, 0, 1, 0, true, 'J', true);

$pdf->writeHTMLCell(
    91, 45,
    105, 48, 
    $shippingAddress, 0, 1, 0, true, 'J', true);

$pdf->writeHTMLCell(
    182, null,
    $pdf->GetX() - 1, null,
    $table, 0, 1, 0, true, 'J', true);

$pdf->writeHTMLCell(
    182, null,
    $pdf->GetX() - 1, null,
    $notes, 0, 1, 0, true, 'J', true);

$x = $pdf->GetX();

$pdf->Line($x, 280, ($x + 180), 280);
$pdf->Line($x, 80, ($x), 280);
$pdf->Line($x+180, 80, ($x + 180), 280);
}

// ---------------------------------------------------------
// Výstupní soubor.
// ---------------------------------------------------------
$pdf->Output('objednavky.pdf', 'I');
?>
